local LDB

local menu = {}
local parent = CreateFrame('Frame')
local mountIndex = nil
local mountSpell = nil
local mountName = nil

local function UpdateDisplay()
	for i = 1, GetNumCompanions("MOUNT") do
	local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
		if lastmountIndex ~= nil then
			mountIndex = lastmountIndex
			mountName = lastmountText
			LDB.text = mountName
			LDB.icon = lastmountIcon
			mountSpell = lastmountSpell
		end
		if issummoned then
			LDB.text = creatureName
			LDB.icon = icon
			lastmountIcon = icon
			lastmountIndex = i
			lastmountSpell = creatureSpellID
			lastmountText = creatureName
			return
		end
		if mountSpell ~= nil then
		local isUsable, notEnoughMana = IsUsableSpell(mountSpell)
			if not isUsable then
				LDB.text = string.format('|cff848484%s|r', mountName)
			else
				LDB.text = mountName
			end
		end
	end
end

local function ModifiedClick(button, i)	
	if IsShiftKeyDown() then
	PickupCompanion("MOUNT", i)
	else
	CallCompanion("MOUNT", i)
	end
end

local function OnTooltipShow(self)
	self:AddLine('|cff00ffffBrokerMounts|r')
	self:AddLine("<Right Click> to open mount list")
	self:AddLine("<Left Click> to mount/dismount")
	self:AddLine("<Shift-Left Click> on mount to pick it up")
	if GetNumCompanions("MOUNT") == 0 then
	self:AddLine("|cffff0000You have no mounts|r")
	end
end

local function OnClick(self, button)
	if button == 'RightButton' then
		ToggleDropDownMenu(1, nil, parent, self, 0, 0)
	end
	if button == 'LeftButton' then
		if IsMounted() then
			Dismount()
		elseif mountIndex ~= nil then
			CallCompanion("MOUNT", mountIndex)
		end
	end
end

local function CreateMenu()
	menu = wipe(menu)
	for i = 1, GetNumCompanions("MOUNT") do
		local creatureID, creatureName, creatureSpellID, icon, issummoned = GetCompanionInfo("MOUNT", i)
		local isUsable, notEnoughMana = IsUsableSpell(creatureSpellID)
		menu.text = string.format('|T%s:26|t |cff848484%s|r', icon, creatureName)
		menu.func = ModifiedClick
		menu.arg1 = i
		menu.notCheckable = 1
		if isUsable then
			menu.text = string.format('|T%s:26|t %s', icon, creatureName)
			menu.notCheckable = 1
			if issummoned then
				menu.text = string.format('|T%s:26|t |cff00ff00%s|r', icon, creatureName)
				menu.notCheckable = 1
			end
		end

		UIDropDownMenu_AddButton(menu)
	end
end

function parent:PLAYER_LOGIN()
	LDB = LibStub('LibDataBroker-1.1'):NewDataObject('BrokerMounts', {
		icon = "Interface\\Icons\\INV_Misc_QuestionMark.blp",
		text = "BrokerMounts",
		type = 'data source',
		OnTooltipShow = OnTooltipShow,
		OnClick = OnClick,
	})
	self:RegisterEvent('SPELL_UPDATE_USABLE')
	self:RegisterEvent('COMPANION_UPDATE')
	self.COMPANION_UPDATE = UpdateDisplay
	self.SPELL_UPDATE_USABLE = UpdateDisplay

	self.initialize = CreateMenu
	self.displayMode = 'MENU'
	
	UpdateDisplay()
end

function parent:PLAYER_LEAVING_WORLD()
lastmountIndex = mountIndex
lastmountText = mountName
lastmountIcon = LDB.icon
lastmountSpell = mountSpell
end

parent:SetScript('OnEvent', function(self, event, ...) self[event](self, ...) end)
parent:RegisterEvent('PLAYER_LOGIN')
parent:RegisterEvent('PLAYER_LEAVING_WORLD')